import {locationChangeAction}from'../actions/router.js';import {CALL_HISTORY_METHOD}from'../constants/routes.js';function appendBasename(location, basename) {
    if (typeof location === 'string' && !location.startsWith(basename)) {
        return basename + location;
    }
    if (typeof location === 'object' && !!location.pathname && !location.pathname.startsWith(basename)) {
        return { ...location, pathname: basename + location.pathname };
    }
    return location;
}
function locationsAreEqual(l, r) {
    if (!l && !r) {
        return true;
    }
    if (l && !r || !l && r) {
        return false;
    }
    return ["pathname", "search", "hash"].every((key) => l[key] === r[key]);
}
const createRouterMiddleware = ({ router, showHistoryAction = false, basename }) => () => 
// @ts-ignore
(next) => (action) => {
    if (action.type !== CALL_HISTORY_METHOD) {
        return next(action);
    }
    // @ts-ignore
    const method = action.payload.method;
    // @ts-ignore
    const args = action.payload.args;
    // eslint-disable-next-line default-case
    switch (method) {
        case 'push': {
            let callArgs = args;
            if (basename && args.length > 0) {
                callArgs = [appendBasename(args[0], basename), ...args.slice(1)];
            }
            const [to, state] = callArgs;
            router.navigate(to, { state });
            break;
        }
        case 'replace': {
            let callArgs = args;
            if (basename && args.length > 0) {
                callArgs = [appendBasename(args[0], basename), ...args.slice(1)];
            }
            const [to, state] = callArgs;
            router.navigate(to, { state, replace: true });
            break;
        }
        case 'go':
            router.navigate(...args);
            break;
        case 'back':
        case 'goBack':
            // @ts-ignore
            router.navigate(-1);
            break;
        case 'forward':
        case 'goForward':
            // @ts-ignore
            router.navigate(1);
            break;
    }
    if (showHistoryAction)
        return next(action);
};
const subscribeReduxRouter = ({ store, router, firstLocate = true }) => {
    const routerLocationSelector = (state) => state['router']?.location || null;
    const { historyAction: action, location } = router.state;
    if (firstLocate) {
        store.dispatch(locationChangeAction(location, action));
    }
    let isNavigatingSynthetically = false;
    // @ts-ignore
    router.subscribe((state) => {
        if (isNavigatingSynthetically) {
            return;
        }
        if (!locationsAreEqual(state.location, routerLocationSelector(store.getState()))) {
            if (state.historyAction !== 'POP') {
                store.dispatch(locationChangeAction(state.location, state.historyAction));
            }
        }
    });
    store.subscribe(() => {
        isNavigatingSynthetically = true;
        const location2 = routerLocationSelector(store.getState());
        if (location2 && !locationsAreEqual(location2, router.state.location)) {
            router.navigate(location2);
        }
        isNavigatingSynthetically = false;
    });
};export{createRouterMiddleware,subscribeReduxRouter};//# sourceMappingURL=router.js.map
